/*ͻ
 ۺ Program       : TBROW.PRG                                                
 ۺ Author        : Gary S. Jorgenson, R.N.                                  
 ۺ Date          : 07/01/93 10:34 am                                        
 ۺ Purpose       : Meta TBrowse object to handle huge databases             
 ۺ Langauge      : Clipper (5.02b)                                          
 ۺ Library       : Class(y) Ver 2                                           
 ͼ
 */

#include "class(y).ch"

CREATE CLASS TBrowDB from TBrowse

EXPORT:

  VAR LStack                 // Array to hold excess TBCol Objects to left
  VAR RStack                 // Array to hold excess TBCol Objects to Right

  METHOD Init
  METHOD AutoFields

  MESSAGE Right METHOD xRight
  MESSAGE Left  METHOD xLeft

  METHOD PanHome
  METHOD PanEnd

END CLASS

*  *
METHOD Init( Top, Left, Bottom, Right )

::Super:Init( Top, Left, Bottom, Right )

::GoBottomBlock := {||dbGoBottom()}
::GoTopBlock    := {||dbGoTop()}

::LStack := {}
::RStack := {}

RETURN ( SELF )

*  *
METHOD FUNCTION AutoFields( vaField )
* Author: Gary S. Jorgenson, R.N.
* Date..: 07/22/93 08:18 pm
* Note..: Create tbcol objects from fields
*  *
LOCAL vnTemp, voColumn

IF vaField = NIL; vaField := DBSTRUCT(); END

FOR vnTemp = 1 to LEN( vaField )

  voColumn := TBColumnNew(vaField[vnTemp,1]             ,;
                          iif(vaField[vnTemp,2]<>'M'    ,;
                          FIELDBLOCK(vaField[vnTemp,1]) ,;
                          {|| "  <Memo>  " }))

  voColumn:cargo := voColumn:heading

  IF vnTemp < 101
    ::addcolumn( voColumn )
  ELSE
    AADD( ::RStack, "" )
    AINS( ::RStack, 1  )
    ::RStack[1] := voColumn
  END

NEXT

RETURN ( SELF )

*  *
METHOD FUNCTION xLEFT()
* Author: Gary S. Jorgenson, R.N.
* Date..: 07/22/93 07:57 pm
* Note..: Move Left
*  *
LOCAL i

IF ::colPos = 1 .AND.  LEN( ::LStack ) > 1

  ::deHiLite()

  FOR i := 1 TO 50

    AADD( ::RStack, ::getColumn( ::ColCount ) )
    ::delColumn( ::ColCount )

    ::insColumn( 1, ATAIL( ::LStack ) )
    ASIZE( ::LStack, LEN( ::LStack )-1 )

    IF EMPTY( ::LStack ); EXIT; END

  NEXT i

  ::ColPos := i

END

::Super:Left()

RETURN ( NIL )


*  *
METHOD FUNCTION xRIGHT()
* Author: Gary S. Jorgenson, R.N.
* Date..: 07/22/93 07:22 pm
* Note..: Move right
*  *
LOCAL i

IF ::colPos = ::colCount .AND.  LEN( ::RStack ) > 1

  ::deHiLite()

  FOR i := 1 TO 50

    AADD( ::LStack, ::getColumn( 1 ) )
    ::delColumn( 1 )

    ::addColumn( ATAIL( ::RStack ) )
    ASIZE( ::RStack, LEN( ::RStack )-1 )

    IF EMPTY( ::RStack ); EXIT; END

  NEXT i

  ::ColPos := ::colCount - i + 1

END

::Super:Right()

RETURN ( NIL )

*  *
METHOD FUNCTION PanHome()
* Author: Gary S. Jorgenson, R.N.
* Date..: 07/23/93 00:21 am
* Note..: Go to 1st column
*  *
WHILE !EMPTY( ::LStack )

  AADD( ::RStack, ::getColumn( ::ColCount ) )
  ::delColumn( ::ColCount )

  ::insColumn( 1, ATAIL( ::LStack ) )
  ASIZE( ::LStack, LEN( ::LStack )-1 )

END

::Super:PanHome()

RETURN ( SELF )

*  *
METHOD FUNCTION PanEnd()
* Author: Gary S. Jorgenson, R.N.
* Date..: 07/23/93 00:24 am
* Note..: Go To the last column
*  *
WHIL !EMPTY( ::RStack )

  AADD( ::LStack, ::getColumn( 1 ) )
  ::delColumn( 1 )

  ::AddColumn( ATAIL( ::RStack ) )
  ASIZE( ::RStack, LEN( ::RStack )-1 )

END

::Super:PanEnd()

RETURN ( SELF )

*  *
* Copyright (C) 1993 SofStar, Inc.
*  *
